﻿package com.afcomponents.common.graphics{
	import flash.utils.*;
	public class Style extends Object{

		/**
		*
		* @static public (constant)
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword ENUM_CONST
		*/
		static public const ENUM_CONST:String = 'ENUM_PARAMS';

		/**
		*
		* @static public (constant)
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword CLONE_METHOD
		*/
		static public const CLONE_METHOD:String = 'clone';

		/**
		*
		* @public
		* @param o
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword Style
		*/
		public function Style(o:Object=null):void{
			super();
			if(o) this.copy(o);
		}

		/**
		*
		* @public
		* @param o
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword copy
		*/
		public function copy(o:Object):void{
			Style.copyStyle(this, o);
		}

		/**
		*
		* @public
		* @return Style
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword clone
		*/
		public function clone():Style{
			var cls:Class = getDefinitionByName(getQualifiedClassName(this)) as Class;
			return new cls(this);
		}

		/**
		*
		* @public
		* @param o
		* @return Style
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword concat
		*/
		public function concat(o:Object):Style{
			var s:Style = this.clone();
			s.copy(o);
			return s;
		}

		/**
		*
		* @static public
		* @param o1
		* @param o2
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword copyStyle
		*/
		static public function copyStyle(o1:Object, o2:Object):void{
			var cls:Class = getDefinitionByName(getQualifiedClassName(o2)) as Class;
			if(cls === Object){
				for(var p in o2) if(o1.hasOwnProperty(p)) o1[p] = o2[p];
				return ;
			}
			var len:uint = 0;
			var arr:Array = null;
			var name:String;
			var value:* = null;
			while(cls && cls!==Object){
				if(cls[ENUM_CONST] && cls[ENUM_CONST] is Array){
					arr = cls[ENUM_CONST];
					len = arr.length;
					for(var i:uint=0; i<len; i++){
						name = arr[i];
						value = o2[name];
						if(value is Array) value = value.concat();
						else if(value && value.hasOwnProperty(CLONE_METHOD) && value[CLONE_METHOD] is Function) o1[name] = value.clone();
						else o1[name] = value;
					}
				}
				cls = getDefinitionByName(getQualifiedSuperclassName(cls)) as Class;
			}
		}
	}
}